a085843d29de42f621a221fb73faf9edc345e9d1
[arvados.git] / build / run-library.sh
1 #!/bin/bash -xe
2 # Copyright (C) The Arvados Authors. All rights reserved.
3 #
4 # SPDX-License-Identifier: AGPL-3.0
5
6 # A library of functions shared by the various scripts in this directory.
7
8 # This is the timestamp about when we merged changed to include licenses
9 # with Arvados packages.  We use it as a heuristic to add revisions for
10 # older packages.
11 LICENSE_PACKAGE_TS=20151208015500
12
13 if [[ -z "$ARVADOS_BUILDING_VERSION" ]]; then
14     RAILS_PACKAGE_ITERATION=1
15 else
16     RAILS_PACKAGE_ITERATION="$ARVADOS_BUILDING_ITERATION"
17 fi
18
19 debug_echo () {
20     echo "$@" >"$STDOUT_IF_DEBUG"
21 }
22
23 find_python_program() {
24     prog="$1"
25     shift
26     for prog in "$@"; do
27         if "$prog" --version >/dev/null 2>&1; then
28             echo "$prog"
29             return 0
30         fi
31     done
32     cat >&2 <<EOF
33 $helpmessage
34
35 Error: $prog (from Python setuptools module) not found
36
37 EOF
38     exit 1
39 }
40
41 format_last_commit_here() {
42     local format="$1"; shift
43     local dir="${1:-.}"; shift
44     TZ=UTC git log -n1 --first-parent "--format=format:$format" "$dir"
45 }
46
47 version_from_git() {
48     # Output the version being built, or if we're building a
49     # dev/prerelease, output a version number based on the git log for
50     # the given $subdir.
51     local subdir="$1"; shift
52     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
53         echo "$ARVADOS_BUILDING_VERSION"
54         return
55     fi
56
57     local git_ts git_hash
58     declare $(format_last_commit_here "git_ts=%ct git_hash=%h" "$subdir")
59     ARVADOS_BUILDING_VERSION="$($WORKSPACE/build/version-at-commit.sh $git_hash)"
60     echo "$ARVADOS_BUILDING_VERSION"
61 }
62
63 nohash_version_from_git() {
64     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
65         echo "$ARVADOS_BUILDING_VERSION"
66         return
67     fi
68     version_from_git | cut -d. -f1-4
69 }
70
71 timestamp_from_git() {
72     local subdir="$1"; shift
73     format_last_commit_here "%ct" "$subdir"
74 }
75
76 calculate_python_sdk_cwl_package_versions() {
77   python_sdk_ts=$(cd sdk/python && timestamp_from_git)
78   cwl_runner_ts=$(cd sdk/cwl && timestamp_from_git)
79
80   python_sdk_version=$(cd sdk/python && nohash_version_from_git)
81   cwl_runner_version=$(cd sdk/cwl && nohash_version_from_git)
82
83   if [[ $python_sdk_ts -gt $cwl_runner_ts ]]; then
84     cwl_runner_version=$python_sdk_version
85   fi
86 }
87
88 handle_python_package () {
89   # This function assumes the current working directory is the python package directory
90   if [ -n "$(find dist -name "*-$(nohash_version_from_git).tar.gz" -print -quit)" ]; then
91     # This package doesn't need rebuilding.
92     return
93   fi
94   # Make sure only to use sdist - that's the only format pip can deal with (sigh)
95   python setup.py $DASHQ_UNLESS_DEBUG sdist
96 }
97
98 handle_ruby_gem() {
99     local gem_name="$1"; shift
100     local gem_version="$(nohash_version_from_git)"
101     local gem_src_dir="$(pwd)"
102
103     if [[ -n "$ONLY_BUILD" ]] && [[ "$gem_name" != "$ONLY_BUILD" ]] ; then
104         return 0
105     fi
106
107     if ! [[ -e "${gem_name}-${gem_version}.gem" ]]; then
108         find -maxdepth 1 -name "${gem_name}-*.gem" -delete
109
110         # -q appears to be broken in gem version 2.2.2
111         $GEM build "$gem_name.gemspec" $DASHQ_UNLESS_DEBUG >"$STDOUT_IF_DEBUG" 2>"$STDERR_IF_DEBUG"
112     fi
113 }
114
115 calculate_go_package_version() {
116   # $__returnvar has the nameref attribute set, which means it is a reference
117   # to another variable that is passed in as the first argument to this function.
118   # see https://www.gnu.org/software/bash/manual/html_node/Shell-Parameters.html
119   local -n __returnvar="$1"; shift
120   local oldpwd="$PWD"
121
122   cd "$WORKSPACE"
123   go mod download
124
125   # Update the version number and build a new package if the vendor
126   # bundle has changed, or the command imports anything from the
127   # Arvados SDK and the SDK has changed.
128   declare -a checkdirs=(go.mod go.sum)
129   while [ -n "$1" ]; do
130       checkdirs+=("$1")
131       shift
132   done
133   if grep -qr git.arvados.org/arvados .; then
134       checkdirs+=(sdk/go lib)
135   fi
136   local timestamp=0
137   for dir in ${checkdirs[@]}; do
138       cd "$WORKSPACE"
139       ts="$(timestamp_from_git "$dir")"
140       if [[ "$ts" -gt "$timestamp" ]]; then
141           version=$(version_from_git "$dir")
142           timestamp="$ts"
143       fi
144   done
145   cd "$oldpwd"
146   __returnvar="$version"
147 }
148
149 # Usage: package_go_binary services/foo arvados-foo "Compute foo to arbitrary precision" [apache-2.0.txt]
150 package_go_binary() {
151     local src_path="$1"; shift
152     local prog="$1"; shift
153     local description="$1"; shift
154     local license_file="${1:-agpl-3.0.txt}"; shift
155
156     if [[ -n "$ONLY_BUILD" ]] && [[ "$prog" != "$ONLY_BUILD" ]]; then
157       # arvados-workbench depends on arvados-server at build time, so even when
158       # only arvados-workbench is being built, we need to build arvados-server too
159       if [[ "$prog" != "arvados-server" ]] || [[ "$ONLY_BUILD" != "arvados-workbench" ]]; then
160         return 0
161       fi
162     fi
163
164     debug_echo "package_go_binary $src_path as $prog"
165
166     local basename="${src_path##*/}"
167     calculate_go_package_version go_package_version $src_path
168
169     cd $WORKSPACE/packages/$TARGET
170     test_package_presence $prog $go_package_version go
171
172     if [[ "$?" != "0" ]]; then
173       return 1
174     fi
175
176     go get -ldflags "-X git.arvados.org/arvados.git/lib/cmd.version=${go_package_version} -X main.version=${go_package_version}" "git.arvados.org/arvados.git/$src_path"
177
178     local -a switches=()
179     systemd_unit="$WORKSPACE/${src_path}/${prog}.service"
180     if [[ -e "${systemd_unit}" ]]; then
181         switches+=(
182             --after-install "${WORKSPACE}/build/go-python-package-scripts/postinst"
183             --before-remove "${WORKSPACE}/build/go-python-package-scripts/prerm"
184             "${systemd_unit}=/lib/systemd/system/${prog}.service")
185     fi
186     switches+=("$WORKSPACE/${license_file}=/usr/share/doc/$prog/${license_file}")
187
188     fpm_build "${WORKSPACE}/${src_path}" "$GOPATH/bin/${basename}=/usr/bin/${prog}" "${prog}" dir "${go_package_version}" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=${description}" "${switches[@]}"
189 }
190
191 # Usage: package_go_so lib/foo arvados_foo.so arvados-foo "Arvados foo library"
192 package_go_so() {
193     local src_path="$1"; shift
194     local sofile="$1"; shift
195     local pkg="$1"; shift
196     local description="$1"; shift
197
198     debug_echo "package_go_so $src_path as $pkg"
199
200     calculate_go_package_version go_package_version $src_path
201     cd $WORKSPACE/packages/$TARGET
202     test_package_presence $pkg $go_package_version go || return 1
203     cd $WORKSPACE/$src_path
204     go build -buildmode=c-shared -o ${GOPATH}/bin/${sofile}
205     cd $WORKSPACE/packages/$TARGET
206     local -a fpmargs=(
207         "--url=https://arvados.org"
208         "--license=Apache License, Version 2.0"
209         "--description=${description}"
210         "$WORKSPACE/apache-2.0.txt=/usr/share/doc/$pkg/apache-2.0.txt"
211     )
212     if [[ -e "$WORKSPACE/$src_path/pam-configs-arvados" ]]; then
213         fpmargs+=("$WORKSPACE/$src_path/pam-configs-arvados=/usr/share/doc/$pkg/pam-configs-arvados-go")
214     fi
215     if [[ -e "$WORKSPACE/$src_path/README" ]]; then
216         fpmargs+=("$WORKSPACE/$src_path/README=/usr/share/doc/$pkg/README")
217     fi
218     fpm_build "${WORKSPACE}/${src_path}" "$GOPATH/bin/${sofile}=/usr/lib/${sofile}" "${pkg}" dir "${go_package_version}" "${fpmargs[@]}"
219 }
220
221 default_iteration() {
222     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
223         echo "$ARVADOS_BUILDING_ITERATION"
224         return
225     fi
226     local package_name="$1"; shift
227     local package_version="$1"; shift
228     local package_type="$1"; shift
229     local iteration=1
230     if [[ $package_version =~ ^0\.1\.([0-9]{14})(\.|$) ]] && \
231            [[ ${BASH_REMATCH[1]} -le $LICENSE_PACKAGE_TS ]]; then
232         iteration=2
233     fi
234     echo $iteration
235 }
236
237 _build_rails_package_scripts() {
238     local pkgname="$1"; shift
239     local destdir="$1"; shift
240     local srcdir="$RUN_BUILD_PACKAGES_PATH/rails-package-scripts"
241     for scriptname in postinst prerm postrm; do
242         cat "$srcdir/$pkgname.sh" "$srcdir/step2.sh" "$srcdir/$scriptname.sh" \
243             >"$destdir/$scriptname" || return $?
244     done
245 }
246
247 rails_package_version() {
248     local pkgname="$1"; shift
249     local srcdir="$1"; shift
250     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
251         echo "$ARVADOS_BUILDING_VERSION"
252         return
253     fi
254     local version="$(version_from_git)"
255     if [ $pkgname = "arvados-api-server" -o $pkgname = "arvados-workbench" ] ; then
256         calculate_go_package_version version cmd/arvados-server "$srcdir"
257     fi
258     echo $version
259 }
260
261 test_rails_package_presence() {
262   local pkgname="$1"; shift
263   local srcdir="$1"; shift
264
265   if [[ -n "$ONLY_BUILD" ]] && [[ "$pkgname" != "$ONLY_BUILD" ]] ; then
266     return 1
267   fi
268
269   tmppwd=`pwd`
270
271   cd $srcdir
272
273   local version="$(rails_package_version "$pkgname" "$srcdir")"
274
275   cd $tmppwd
276
277   test_package_presence $pkgname $version rails "$RAILS_PACKAGE_ITERATION"
278 }
279
280 get_complete_package_name() {
281   # if the errexit flag is set, unset it until this function returns
282   # otherwise, the shift calls below will abort the program if optional arguments are not supplied
283   if [ -o errexit ]; then
284     set +e
285     trap 'set -e' RETURN
286   fi
287   # $__returnvar has the nameref attribute set, which means it is a reference
288   # to another variable that is passed in as the first argument to this function.
289   # see https://www.gnu.org/software/bash/manual/html_node/Shell-Parameters.html
290   local -n __returnvar="$1"; shift
291   local pkgname="$1"; shift
292   local version="$1"; shift
293   local pkgtype="$1"; shift
294   local iteration="$1"; shift
295   local arch="$1"; shift
296   if [[ "$iteration" == "" ]]; then
297       iteration="$(default_iteration "$pkgname" "$version" "$pkgtype")"
298   fi
299
300   if [[ "$arch" == "" ]]; then
301     rpm_architecture="x86_64"
302     deb_architecture="amd64"
303
304     if [[ "$pkgtype" =~ ^(src)$ ]]; then
305       rpm_architecture="noarch"
306       deb_architecture="all"
307     fi
308
309     # These python packages have binary components
310     if [[ "$pkgname" =~ (ruamel|ciso|pycrypto|pyyaml) ]]; then
311       rpm_architecture="x86_64"
312       deb_architecture="amd64"
313     fi
314   else
315     rpm_architecture=$arch
316     deb_architecture=$arch
317   fi
318
319   local complete_pkgname="${pkgname}_$version${iteration:+-$iteration}_$deb_architecture.deb"
320   if [[ "$FORMAT" == "rpm" ]]; then
321       # rpm packages get iteration 1 if we don't supply one
322       iteration=${iteration:-1}
323       complete_pkgname="$pkgname-$version-${iteration}.$rpm_architecture.rpm"
324   fi
325   __returnvar=${complete_pkgname}
326 }
327
328 # Test if the package already exists, if not return 0, if it does return 1
329 test_package_presence() {
330     local pkgname="$1"; shift
331     local version="$1"; shift
332     local pkgtype="$1"; shift
333     local iteration="$1"; shift
334     local arch="$1"; shift
335     if [[ -n "$ONLY_BUILD" ]] && [[ "$pkgname" != "$ONLY_BUILD" ]] ; then
336       # arvados-workbench depends on arvados-server at build time, so even when
337       # only arvados-workbench is being built, we need to build arvados-server too
338       if [[ "$pkgname" != "arvados-server" ]] || [[ "$ONLY_BUILD" != "arvados-workbench" ]]; then
339         return 1
340       fi
341     fi
342
343     local full_pkgname
344     get_complete_package_name full_pkgname $pkgname $version $pkgtype $iteration $arch
345
346     # See if we can skip building the package, only if it already exists in the
347     # processed/ directory. If so, move it back to the packages directory to make
348     # sure it gets picked up by the test and/or upload steps.
349     # Get the list of packages from the repos
350
351     if [[ "$FORCE_BUILD" == "1" ]]; then
352       echo "Package $full_pkgname build forced with --force-build, building"
353     elif [[ "$FORMAT" == "deb" ]]; then
354       declare -A dd
355       dd[debian9]=stretch
356       dd[debian10]=buster
357       dd[ubuntu1604]=xenial
358       dd[ubuntu1804]=bionic
359       D=${dd[$TARGET]}
360       if [ ${pkgname:0:3} = "lib" ]; then
361         repo_subdir=${pkgname:0:4}
362       else
363         repo_subdir=${pkgname:0:1}
364       fi
365
366       repo_pkg_list=$(curl -s -o - http://apt.arvados.org/pool/${D}-dev/main/${repo_subdir}/${pkgname}/)
367       echo "${repo_pkg_list}" |grep -q ${full_pkgname}
368       if [ $? -eq 0 ] ; then
369         echo "Package $full_pkgname exists upstream, not rebuilding, downloading instead!"
370         curl -s -o "$WORKSPACE/packages/$TARGET/${full_pkgname}" http://apt.arvados.org/pool/${D}-dev/main/${repo_subdir}/${pkgname}/${full_pkgname}
371         return 1
372       elif test -f "$WORKSPACE/packages/$TARGET/processed/${full_pkgname}" ; then
373         echo "Package $full_pkgname exists, not rebuilding!"
374         return 1
375       else
376         echo "Package $full_pkgname not found, building"
377         return 0
378       fi
379     else
380       centos_repo="http://rpm.arvados.org/CentOS/7/dev/x86_64/"
381
382       repo_pkg_list=$(curl -s -o - ${centos_repo})
383       echo ${repo_pkg_list} |grep -q ${full_pkgname}
384       if [ $? -eq 0 ]; then
385         echo "Package $full_pkgname exists upstream, not rebuilding, downloading instead!"
386         curl -s -o "$WORKSPACE/packages/$TARGET/${full_pkgname}" ${centos_repo}${full_pkgname}
387         return 1
388       elif test -f "$WORKSPACE/packages/$TARGET/processed/${full_pkgname}" ; then
389         echo "Package $full_pkgname exists, not rebuilding!"
390         return 1
391       else
392         echo "Package $full_pkgname not found, building"
393         return 0
394       fi
395     fi
396 }
397
398 handle_rails_package() {
399     local pkgname="$1"; shift
400
401     if [[ -n "$ONLY_BUILD" ]] && [[ "$pkgname" != "$ONLY_BUILD" ]] ; then
402         return 0
403     fi
404     local srcdir="$1"; shift
405     cd "$srcdir"
406     local license_path="$1"; shift
407     local version="$(rails_package_version "$pkgname" "$srcdir")"
408     echo "$version" >package-build.version
409     local scripts_dir="$(mktemp --tmpdir -d "$pkgname-XXXXXXXX.scripts")" && \
410     (
411         set -e
412         _build_rails_package_scripts "$pkgname" "$scripts_dir"
413         cd "$srcdir"
414         mkdir -p tmp
415         git rev-parse HEAD >git-commit.version
416         bundle package --all
417     )
418     if [[ 0 != "$?" ]] || ! cd "$WORKSPACE/packages/$TARGET"; then
419         echo "ERROR: $pkgname package prep failed" >&2
420         rm -rf "$scripts_dir"
421         EXITCODE=1
422         return 1
423     fi
424     local railsdir="/var/www/${pkgname%-server}/current"
425     local -a pos_args=("$srcdir/=$railsdir" "$pkgname" dir "$version")
426     local license_arg="$license_path=$railsdir/$(basename "$license_path")"
427     local -a switches=(--after-install "$scripts_dir/postinst"
428                        --before-remove "$scripts_dir/prerm"
429                        --after-remove "$scripts_dir/postrm")
430     if [[ -z "$ARVADOS_BUILDING_VERSION" ]]; then
431         switches+=(--iteration $RAILS_PACKAGE_ITERATION)
432     fi
433     # For some reason fpm excludes need to not start with /.
434     local exclude_root="${railsdir#/}"
435     # .git and packages are for the SSO server, which is built from its
436     # repository root.
437     local -a exclude_list=(.git packages tmp log coverage Capfile\* \
438                            config/deploy\* config/application.yml)
439     # for arvados-workbench, we need to have the (dummy) config/database.yml in the package
440     if  [[ "$pkgname" != "arvados-workbench" ]]; then
441       exclude_list+=('config/database.yml')
442     fi
443     for exclude in ${exclude_list[@]}; do
444         switches+=(-x "$exclude_root/$exclude")
445     done
446     fpm_build "${srcdir}" "${pos_args[@]}" "${switches[@]}" \
447               -x "$exclude_root/vendor/cache-*" \
448               -x "$exclude_root/vendor/bundle" "$@" "$license_arg"
449     rm -rf "$scripts_dir"
450 }
451
452 # Build python packages with a virtualenv built-in
453 fpm_build_virtualenv () {
454   PKG=$1
455   shift
456   PKG_DIR=$1
457   shift
458   PACKAGE_TYPE=${1:-python}
459   shift
460
461   # Set up
462   STDOUT_IF_DEBUG=/dev/null
463   STDERR_IF_DEBUG=/dev/null
464   DASHQ_UNLESS_DEBUG=-q
465   if [[ "$DEBUG" != "0" ]]; then
466       STDOUT_IF_DEBUG=/dev/stdout
467       STDERR_IF_DEBUG=/dev/stderr
468       DASHQ_UNLESS_DEBUG=
469   fi
470   if [[ "$ARVADOS_BUILDING_ITERATION" == "" ]]; then
471     ARVADOS_BUILDING_ITERATION=1
472   fi
473
474   local python=""
475   case "$PACKAGE_TYPE" in
476     python3)
477         python=python3
478         if [[ "$FORMAT" != "rpm" ]]; then
479           pip=pip3
480         else
481           # In CentOS, we use a different mechanism to get the right version of pip
482           pip=pip
483         fi
484         PACKAGE_PREFIX=$PYTHON3_PKG_PREFIX
485         ;;
486   esac
487
488   if [[ "$PKG" != "arvados-docker-cleaner" ]]; then
489     PYTHON_PKG=$PACKAGE_PREFIX-$PKG
490   else
491     # Exception to our package naming convention
492     PYTHON_PKG=$PKG
493   fi
494
495   # arvados-python-client sdist should always be built, to be available
496   # for other dependent packages.
497   if [[ -n "$ONLY_BUILD" ]] && [[ "arvados-python-client" != "$PKG" ]] && [[ "$PYTHON_PKG" != "$ONLY_BUILD" ]] && [[ "$PKG" != "$ONLY_BUILD" ]]; then
498     return 0
499   fi
500
501   cd $WORKSPACE/$PKG_DIR
502
503   rm -rf dist/*
504
505   # Get the latest setuptools
506   if ! $pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'; then
507     echo "Error, unable to upgrade setuptools with"
508     echo "  $pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'"
509     exit 1
510   fi
511   # filter a useless warning (when building the cwltest package) from the stderr output
512   if ! $python setup.py $DASHQ_UNLESS_DEBUG sdist 2> >(grep -v 'warning: no previously-included files matching'); then
513     echo "Error, unable to run $python setup.py sdist for $PKG"
514     exit 1
515   fi
516
517   PACKAGE_PATH=`(cd dist; ls *tar.gz)`
518
519   if [[ "arvados-python-client" == "$PKG" ]]; then
520     PYSDK_PATH=`pwd`/dist/
521   fi
522
523   if [[ -n "$ONLY_BUILD" ]] && [[ "$PYTHON_PKG" != "$ONLY_BUILD" ]] && [[ "$PKG" != "$ONLY_BUILD" ]]; then
524     return 0
525   fi
526
527   # Determine the package version from the generated sdist archive
528   if [[ -n "$ARVADOS_BUILDING_VERSION" ]] ; then
529       UNFILTERED_PYTHON_VERSION=$(echo -n $ARVADOS_BUILDING_VERSION)
530       PYTHON_VERSION=$(echo -n $ARVADOS_BUILDING_VERSION | sed s/~rc/rc/g)
531   else
532       UNFILTERED_PYTHON_VERSION=$(awk '($1 == "Version:"){print $2}' *.egg-info/PKG-INFO)
533       PYTHON_VERSION=$(awk '($1 == "Version:"){print $2}' *.egg-info/PKG-INFO)
534   fi
535
536   # See if we actually need to build this package; does it exist already?
537   # We can't do this earlier than here, because we need PYTHON_VERSION...
538   # This isn't so bad; the sdist call above is pretty quick compared to
539   # the invocation of virtualenv and fpm, below.
540   if ! test_package_presence "$PYTHON_PKG" $UNFILTERED_PYTHON_VERSION $PACKAGE_TYPE $ARVADOS_BUILDING_ITERATION; then
541     return 0
542   fi
543
544   echo "Building $FORMAT package for $PKG from $PKG_DIR"
545
546   # Package the sdist in a virtualenv
547   echo "Creating virtualenv..."
548
549   cd dist
550
551   rm -rf build
552   rm -f $PYTHON_PKG*deb
553   echo "virtualenv version: `virtualenv --version`"
554   virtualenv_command="virtualenv --python `which $python` $DASHQ_UNLESS_DEBUG build/usr/share/$python/dist/$PYTHON_PKG"
555
556   if ! $virtualenv_command; then
557     echo "Error, unable to run"
558     echo "  $virtualenv_command"
559     exit 1
560   fi
561
562   if ! build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U pip; then
563     echo "Error, unable to upgrade pip with"
564     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U pip"
565     exit 1
566   fi
567   echo "pip version:        `build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip --version`"
568
569   if ! build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'; then
570     echo "Error, unable to upgrade setuptools with"
571     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'"
572     exit 1
573   fi
574   echo "setuptools version: `build/usr/share/$python/dist/$PYTHON_PKG/bin/$python -c 'import setuptools; print(setuptools.__version__)'`"
575
576   if ! build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U wheel; then
577     echo "Error, unable to upgrade wheel with"
578     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U wheel"
579     exit 1
580   fi
581   echo "wheel version:      `build/usr/share/$python/dist/$PYTHON_PKG/bin/wheel version`"
582
583   if [[ "$TARGET" != "centos7" ]] || [[ "$PYTHON_PKG" != "python-arvados-fuse" ]]; then
584     build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -f $PYSDK_PATH $PACKAGE_PATH
585   else
586     # centos7 needs these special tweaks to install python-arvados-fuse
587     build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG docutils
588     PYCURL_SSL_LIBRARY=nss build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -f $PYSDK_PATH $PACKAGE_PATH
589   fi
590
591   if [[ "$?" != "0" ]]; then
592     echo "Error, unable to run"
593     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -f $PYSDK_PATH $PACKAGE_PATH"
594     exit 1
595   fi
596
597   cd build/usr/share/$python/dist/$PYTHON_PKG/
598
599   # Replace the shebang lines in all python scripts, and handle the activate
600   # scripts too. This is a functional replacement of the 237 line
601   # virtualenv_tools.py script that doesn't work in python3 without serious
602   # patching, minus the parts we don't need (modifying pyc files, etc).
603   for binfile in `ls bin/`; do
604     if ! file --mime bin/$binfile |grep -q binary; then
605       # Not a binary file
606       if [[ "$binfile" =~ ^activate(.csh|.fish|)$ ]]; then
607         # these 'activate' scripts need special treatment
608         sed -i "s/VIRTUAL_ENV=\".*\"/VIRTUAL_ENV=\"\/usr\/share\/$python\/dist\/$PYTHON_PKG\"/" bin/$binfile
609         sed -i "s/VIRTUAL_ENV \".*\"/VIRTUAL_ENV \"\/usr\/share\/$python\/dist\/$PYTHON_PKG\"/" bin/$binfile
610       else
611         if grep -q -E '^#!.*/bin/python\d?' bin/$binfile; then
612           # Replace shebang line
613           sed -i "1 s/^.*$/#!\/usr\/share\/$python\/dist\/$PYTHON_PKG\/bin\/python/" bin/$binfile
614         fi
615       fi
616     fi
617   done
618
619   cd - >$STDOUT_IF_DEBUG
620
621   find build -iname '*.pyc' -exec rm {} \;
622   find build -iname '*.pyo' -exec rm {} \;
623
624   # Finally, generate the package
625   echo "Creating package..."
626
627   declare -a COMMAND_ARR=("fpm" "-s" "dir" "-t" "$FORMAT")
628
629   if [[ "$MAINTAINER" != "" ]]; then
630     COMMAND_ARR+=('--maintainer' "$MAINTAINER")
631   fi
632
633   if [[ "$VENDOR" != "" ]]; then
634     COMMAND_ARR+=('--vendor' "$VENDOR")
635   fi
636
637   COMMAND_ARR+=('--url' 'https://arvados.org')
638
639   # Get description
640   DESCRIPTION=`grep '\sdescription' $WORKSPACE/$PKG_DIR/setup.py|cut -f2 -d=|sed -e "s/[',\\"]//g"`
641   COMMAND_ARR+=('--description' "$DESCRIPTION")
642
643   # Get license string
644   LICENSE_STRING=`grep license $WORKSPACE/$PKG_DIR/setup.py|cut -f2 -d=|sed -e "s/[',\\"]//g"`
645   COMMAND_ARR+=('--license' "$LICENSE_STRING")
646
647   if [[ "$DEBUG" != "0" ]]; then
648     COMMAND_ARR+=('--verbose' '--log' 'info')
649   fi
650
651   COMMAND_ARR+=('-v' $(echo "$PYTHON_VERSION" | sed s/rc/~rc/g))
652   COMMAND_ARR+=('--iteration' "$ARVADOS_BUILDING_ITERATION")
653   COMMAND_ARR+=('-n' "$PYTHON_PKG")
654   COMMAND_ARR+=('-C' "build")
655
656   systemd_unit="$WORKSPACE/$PKG_DIR/$PKG.service"
657   if [[ -e "${systemd_unit}" ]]; then
658     COMMAND_ARR+=('--after-install' "${WORKSPACE}/build/go-python-package-scripts/postinst")
659     COMMAND_ARR+=('--before-remove' "${WORKSPACE}/build/go-python-package-scripts/prerm")
660   fi
661
662   COMMAND_ARR+=('--depends' "$PYTHON3_PACKAGE")
663
664   # avoid warning
665   COMMAND_ARR+=('--deb-no-default-config-files')
666
667   # Append --depends X and other arguments specified by fpm-info.sh in
668   # the package source dir. These are added last so they can override
669   # the arguments added by this script.
670   declare -a fpm_args=()
671   declare -a fpm_depends=()
672
673   fpminfo="$WORKSPACE/$PKG_DIR/fpm-info.sh"
674   if [[ -e "$fpminfo" ]]; then
675     echo "Loading fpm overrides from $fpminfo"
676     if ! source "$fpminfo"; then
677       echo "Error, unable to source $WORKSPACE/$PKG_DIR/fpm-info.sh for $PKG"
678       exit 1
679     fi
680   fi
681
682   for i in "${fpm_depends[@]}"; do
683     COMMAND_ARR+=('--depends' "$i")
684   done
685
686   # make sure the systemd service file ends up in the right place
687   # used by arvados-docker-cleaner
688   if [[ -e "${systemd_unit}" ]]; then
689     COMMAND_ARR+=("usr/share/$python/dist/$PKG/share/doc/$PKG/$PKG.service=/lib/systemd/system/$PKG.service")
690   fi
691
692   COMMAND_ARR+=("${fpm_args[@]}")
693
694   # Make sure to install all our package binaries in /usr/bin.
695   # We have to walk $WORKSPACE/$PKG_DIR/bin rather than
696   # $WORKSPACE/build/usr/share/$python/dist/$PYTHON_PKG/bin/ to get the list
697   # because the latter also includes all the python binaries for the virtualenv.
698   # We have to take the copies of our binaries from the latter directory, though,
699   # because those are the ones we rewrote the shebang line of, above.
700   if [[ -e "$WORKSPACE/$PKG_DIR/bin" ]]; then
701     for binary in `ls $WORKSPACE/$PKG_DIR/bin`; do
702       COMMAND_ARR+=("usr/share/$python/dist/$PYTHON_PKG/bin/$binary=/usr/bin/")
703     done
704   fi
705
706   # the python-arvados-cwl-runner package comes with cwltool, expose that version
707   if [[ -e "$WORKSPACE/$PKG_DIR/dist/build/usr/share/python2.7/dist/python-arvados-cwl-runner/bin/cwltool" ]]; then
708     COMMAND_ARR+=("usr/share/python2.7/dist/python-arvados-cwl-runner/bin/cwltool=/usr/bin/")
709   fi
710
711   COMMAND_ARR+=(".")
712
713   debug_echo -e "\n${COMMAND_ARR[@]}\n"
714
715   FPM_RESULTS=$("${COMMAND_ARR[@]}")
716   FPM_EXIT_CODE=$?
717
718   # if something went wrong and debug is off, print out the fpm command that errored
719   if ! fpm_verify $FPM_EXIT_CODE $FPM_RESULTS && [[ "$STDOUT_IF_DEBUG" == "/dev/null" ]]; then
720     echo "fpm returned an error executing the command:"
721     echo
722     echo -e "\n${COMMAND_ARR[@]}\n"
723   else
724     echo `ls *$FORMAT`
725     mv $WORKSPACE/$PKG_DIR/dist/*$FORMAT $WORKSPACE/packages/$TARGET/
726   fi
727   echo
728 }
729
730 # Build packages for everything
731 fpm_build () {
732   # Source dir where fpm-info.sh (if any) will be found.
733   SRC_DIR=$1
734   shift
735   # The package source.  Depending on the source type, this can be a
736   # path, or the name of the package in an upstream repository (e.g.,
737   # pip).
738   PACKAGE=$1
739   shift
740   # The name of the package to build.
741   PACKAGE_NAME=$1
742   shift
743   # The type of source package.  Passed to fpm -s.  Default "dir".
744   PACKAGE_TYPE=${1:-dir}
745   shift
746   # Optional: the package version number.  Passed to fpm -v.
747   VERSION=$1
748   shift
749
750   if [[ -n "$ONLY_BUILD" ]] && [[ "$PACKAGE_NAME" != "$ONLY_BUILD" ]] && [[ "$PACKAGE" != "$ONLY_BUILD" ]] ; then
751     # arvados-workbench depends on arvados-server at build time, so even when
752     # only arvados-workbench is being built, we need to build arvados-server too
753     if [[ "$PACKAGE_NAME" != "arvados-server" ]] || [[ "$ONLY_BUILD" != "arvados-workbench" ]]; then
754       return 0
755     fi
756   fi
757
758   local default_iteration_value="$(default_iteration "$PACKAGE" "$VERSION" "$PACKAGE_TYPE")"
759
760   declare -a COMMAND_ARR=("fpm" "-s" "$PACKAGE_TYPE" "-t" "$FORMAT")
761   if [ python = "$PACKAGE_TYPE" ] && [ deb = "$FORMAT" ]; then
762       # Dependencies are built from setup.py.  Since setup.py will never
763       # refer to Debian package iterations, it doesn't make sense to
764       # enforce those in the .deb dependencies.
765       COMMAND_ARR+=(--deb-ignore-iteration-in-dependencies)
766   fi
767
768   if [[ "$DEBUG" != "0" ]]; then
769     COMMAND_ARR+=('--verbose' '--log' 'info')
770   fi
771
772   if [[ -n "$PACKAGE_NAME" ]]; then
773     COMMAND_ARR+=('-n' "$PACKAGE_NAME")
774   fi
775
776   if [[ "$MAINTAINER" != "" ]]; then
777     COMMAND_ARR+=('--maintainer' "$MAINTAINER")
778   fi
779
780   if [[ "$VENDOR" != "" ]]; then
781     COMMAND_ARR+=('--vendor' "$VENDOR")
782   fi
783
784   if [[ "$VERSION" != "" ]]; then
785     COMMAND_ARR+=('-v' "$VERSION")
786   fi
787   if [[ -n "$default_iteration_value" ]]; then
788       # We can always add an --iteration here.  If another one is specified in $@,
789       # that will take precedence, as desired.
790       COMMAND_ARR+=(--iteration "$default_iteration_value")
791   fi
792
793   # Append --depends X and other arguments specified by fpm-info.sh in
794   # the package source dir. These are added last so they can override
795   # the arguments added by this script.
796   declare -a fpm_args=()
797   declare -a build_depends=()
798   declare -a fpm_depends=()
799   declare -a fpm_exclude=()
800   if [[ ! -d "$SRC_DIR" ]]; then
801       echo >&2 "BUG: looking in wrong dir for fpm-info.sh: $pkgdir"
802       exit 1
803   fi
804   fpminfo="${SRC_DIR}/fpm-info.sh"
805   if [[ -e "$fpminfo" ]]; then
806       debug_echo "Loading fpm overrides from $fpminfo"
807       source "$fpminfo"
808   fi
809   for pkg in "${build_depends[@]}"; do
810       if [[ $TARGET =~ debian|ubuntu ]]; then
811           pkg_deb=$(ls "$WORKSPACE/packages/$TARGET/$pkg_"*.deb | sort -rg | awk 'NR==1')
812           if [[ -e $pkg_deb ]]; then
813               echo "Installing build_dep $pkg from $pkg_deb"
814               dpkg -i "$pkg_deb"
815           else
816               echo "Attemping to install build_dep $pkg using apt-get"
817               apt-get install -y "$pkg"
818           fi
819           apt-get -y -f install
820       else
821           pkg_rpm=$(ls "$WORKSPACE/packages/$TARGET/$pkg"-[0-9]*.rpm | sort -rg | awk 'NR==1')
822           if [[ -e $pkg_rpm ]]; then
823               echo "Installing build_dep $pkg from $pkg_rpm"
824               rpm -i "$pkg_rpm"
825           else
826               echo "Attemping to install build_dep $pkg"
827               rpm -i "$pkg"
828           fi
829       fi
830   done
831   for i in "${fpm_depends[@]}"; do
832     COMMAND_ARR+=('--depends' "$i")
833   done
834   for i in "${fpm_exclude[@]}"; do
835     COMMAND_ARR+=('--exclude' "$i")
836   done
837
838   COMMAND_ARR+=("${fpm_args[@]}")
839
840   # Append remaining function arguments directly to fpm's command line.
841   for i; do
842     COMMAND_ARR+=("$i")
843   done
844
845   COMMAND_ARR+=("$PACKAGE")
846
847   debug_echo -e "\n${COMMAND_ARR[@]}\n"
848
849   FPM_RESULTS=$("${COMMAND_ARR[@]}")
850   FPM_EXIT_CODE=$?
851
852   fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
853
854   # if something went wrong and debug is off, print out the fpm command that errored
855   if [[ 0 -ne $? ]] && [[ "$STDOUT_IF_DEBUG" == "/dev/null" ]]; then
856     echo -e "\n${COMMAND_ARR[@]}\n"
857   fi
858 }
859
860 # verify build results
861 fpm_verify () {
862   FPM_EXIT_CODE=$1
863   shift
864   FPM_RESULTS=$@
865
866   FPM_PACKAGE_NAME=''
867   if [[ $FPM_RESULTS =~ ([A-Za-z0-9_\.-]*\.)(deb|rpm) ]]; then
868     FPM_PACKAGE_NAME=${BASH_REMATCH[1]}${BASH_REMATCH[2]}
869   fi
870
871   if [[ "$FPM_PACKAGE_NAME" == "" ]]; then
872     EXITCODE=1
873     echo
874     echo "Error: $PACKAGE: Unable to figure out package name from fpm results:"
875     echo
876     echo $FPM_RESULTS
877     echo
878     return 1
879   elif [[ "$FPM_RESULTS" =~ "File already exists" ]]; then
880     echo "Package $FPM_PACKAGE_NAME exists, not rebuilding"
881     return 0
882   elif [[ 0 -ne "$FPM_EXIT_CODE" ]]; then
883     EXITCODE=1
884     echo "Error building package for $1:\n $FPM_RESULTS"
885     return 1
886   fi
887 }
888
889 install_package() {
890   PACKAGES=$@
891   if [[ "$FORMAT" == "deb" ]]; then
892     $SUDO apt-get install $PACKAGES --yes
893   elif [[ "$FORMAT" == "rpm" ]]; then
894     $SUDO yum -q -y install $PACKAGES
895   fi
896 }
897
898 title() {
899     printf '%s %s\n' "=======" "$1"
900 }
901
902 checkexit() {
903     if [[ "$1" != "0" ]]; then
904         title "$2 -- FAILED"
905         failures+=("$2 (`timer`)")
906     else
907         successes+=("$2 (`timer`)")
908     fi
909 }
910
911 timer_reset() {
912     t0=$SECONDS
913 }
914
915 timer() {
916     if [[ -n "$t0" ]]; then
917         echo -n "$(($SECONDS - $t0))s"
918     fi
919 }
920
921 report_outcomes() {
922     for x in "${successes[@]}"
923     do
924         echo "Pass: $x"
925     done
926
927     if [[ ${#failures[@]} == 0 ]]
928     then
929         if [[ ${#successes[@]} != 0 ]]; then
930            echo "All test suites passed."
931         fi
932     else
933         echo "Failures (${#failures[@]}):"
934         for x in "${failures[@]}"
935         do
936             echo "Fail: $x"
937         done
938     fi
939 }